org.mozilla.javascript.typedarrays

## Class NativeArrayBufferView

- java.lang.Object
- - org.mozilla.javascript.ScriptableObject
  - - org.mozilla.javascript.IdScriptableObject
    - - org.mozilla.javascript.typedarrays.NativeArrayBufferView

- All Implemented Interfaces:
    java.io.Serializable, ConstProperties, DebuggableObject, IdFunctionCall, Scriptable
  Direct Known Subclasses:
    NativeDataView, NativeTypedArrayView

      public abstract class NativeArrayBufferView
      extends IdScriptableObject

  This class is the abstract parent for all views of the array. It shows a view of the underlying NativeArrayBuffer. Many views may simultaneously share the same buffer, and changes to one will affect all.
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected NativeArrayBuffer` | `arrayBuffer` Many view objects can share the same backing array
    `protected int` | `byteLength` The length, in bytes, of the portion of the backing array that we use
    `protected int` | `offset` The offset, in bytes, from the start of the backing array

    - ### Fields inherited from class org.mozilla.javascript.ScriptableObject

      `CONST, DONTENUM, EMPTY, PERMANENT, READONLY, UNINITIALIZED_CONST`

    - ### Fields inherited from interface org.mozilla.javascript.Scriptable

      `NOT_FOUND`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `` | `NativeArrayBufferView()`
    `protected` | `NativeArrayBufferView(NativeArrayBuffer ab, int offset, int byteLength)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected int` | `findInstanceIdInfo(java.lang.String s)` Map name to id of instance property.
    `NativeArrayBuffer` | `getBuffer()` Return the buffer that backs this view.
    `int` | `getByteLength()` Return the length, in bytes, of the part of the buffer that this view represents.
    `int` | `getByteOffset()` Return the offset in bytes from the start of the buffer that this view represents.
    `protected java.lang.String` | `getInstanceIdName(int id)` Map id back to property name it defines.
    `protected java.lang.Object` | `getInstanceIdValue(int id)` Get id value.
    `protected int` | `getMaxInstanceId()` Get maximum id findInstanceIdInfo can generate.
    `protected static boolean` | `isArg(java.lang.Object[] args, int i)`

    - ### Methods inherited from class org.mozilla.javascript.IdScriptableObject

      `activatePrototypeMap, addIdFunctionProperty, defaultGet, defaultHas, defaultPut, defineOwnProperty, delete, execIdCall, exportAsJSClass, fillConstructorProperties, findPrototypeId, get, getAttributes, getOwnPropertyDescriptor, has, hasPrototypeMap, incompatibleCallError, initPrototypeConstructor, initPrototypeId, initPrototypeMethod, initPrototypeValue, instanceIdInfo, put, setAttributes, setInstanceIdAttributes, setInstanceIdValue`

    - ### Methods inherited from class org.mozilla.javascript.ScriptableObject

      `applyDescriptorToAttributeBitset, associateValue, avoidObjectDetection, buildDataDescriptor, callMethod, callMethod, checkPropertyChange, checkPropertyDefinition, defineClass, defineClass, defineClass, defineConst, defineConstProperty, defineFunctionProperties, defineOwnProperties, defineOwnProperty, defineProperty, defineProperty, defineProperty, defineProperty, delete, deleteProperty, deleteProperty, ensureScriptable, ensureScriptableObject, equivalentValues, get, get, getAllIds, getArrayPrototype, getAssociatedValue, getAttributes, getAttributes, getAttributes, getClassName, getClassPrototype, getDefaultValue, getDefaultValue, getExternalArrayData, getExternalArrayLength, getFunctionPrototype, getGetterOrSetter, getIds, getObjectPrototype, getParentScope, getProperty, getProperty, getPropertyIds, getPrototype, getSlot, getTopLevelScope, getTopScopeValue, getTypedProperty, getTypedProperty, getTypeOf, has, hasInstance, hasProperty, hasProperty, isAccessorDescriptor, isConst, isDataDescriptor, isEmpty, isExtensible, isFalse, isGenericDescriptor, isGetterOrSetter, isSealed, isTrue, preventExtensions, put, putConst, putConstProperty, putProperty, putProperty, redefineProperty, sameValue, sealObject, setAttributes, setAttributes, setAttributes, setExternalArrayData, setGetterOrSetter, setParentScope, setPrototype, size`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### arrayBuffer

          protected final NativeArrayBuffer arrayBuffer

      Many view objects can share the same backing array

    - #### offset

          protected final int offset

      The offset, in bytes, from the start of the backing array

    - #### byteLength

          protected final int byteLength

      The length, in bytes, of the portion of the backing array that we use

  - ### Constructor Detail

    - #### NativeArrayBufferView

          public NativeArrayBufferView()

    - #### NativeArrayBufferView

          protected NativeArrayBufferView(NativeArrayBuffer ab,
                                          int offset,
                                          int byteLength)

  - ### Method Detail

    - #### getBuffer

          public NativeArrayBuffer getBuffer()

      Return the buffer that backs this view.

    - #### getByteOffset

          public int getByteOffset()

      Return the offset in bytes from the start of the buffer that this view represents.

    - #### getByteLength

          public int getByteLength()

      Return the length, in bytes, of the part of the buffer that this view represents.

    - #### isArg

          protected static boolean isArg(java.lang.Object[] args,
                                         int i)

    - #### getMaxInstanceId

          protected int getMaxInstanceId()

      Description copied from class: `IdScriptableObject`
      Get maximum id findInstanceIdInfo can generate.
      Overrides:
        `getMaxInstanceId` in class `IdScriptableObject`

    - #### getInstanceIdName

          protected java.lang.String getInstanceIdName(int id)

      Description copied from class: `IdScriptableObject`
      Map id back to property name it defines.
      Overrides:
        `getInstanceIdName` in class `IdScriptableObject`

    - #### getInstanceIdValue

          protected java.lang.Object getInstanceIdValue(int id)

      Description copied from class: `IdScriptableObject`
      Get id value. If id value is constant, descendant can call cacheIdValue to store value in the permanent cache. Default implementation creates IdFunctionObject instance for given id and cache its value
      Overrides:
        `getInstanceIdValue` in class `IdScriptableObject`

    - #### findInstanceIdInfo

          protected int findInstanceIdInfo(java.lang.String s)

      Description copied from class: `IdScriptableObject`
      Map name to id of instance property. Should return 0 if not found or the result of `IdScriptableObject.instanceIdInfo(int, int)`.
      Overrides:
        `findInstanceIdInfo` in class `IdScriptableObject`